<cfcomponent >
	<cfset this.ds = "employeeDS">
	
	<cffunction name="getEmployees" returntype="Array" access="remote" returnformat="JSON" 
		hint="Fetches employee rows from Employee table and returns array of EmployeeTO components">

		<cfset result = ArrayNew(1)>
		
		<cfquery datasource="#this.ds#" name="empRs">
			select * from EMPLOYEE order by FIRST_NAME
		</cfquery>
		
		<cfloop query="empRs">
			<cfset var empStruct = {"id":id, "firstName":first_name, 
									"lastName": last_name, "address":address}>
			<cfset arrayAppend(result,empStruct)>
		</cfloop>
		
		<cfreturn result>
		 
	</cffunction>
	
	<cffunction name="addEmployee" access="remote" returntype="numeric" 
		hint="Inserts a new employee record in the able">
		<cfargument name="emp" type="struct" >
		
		<cfquery datasource="#this.ds#" result="newEmpResult">
			insert into EMPLOYEE (FIRST_NAME,LAST_NAME,ADDRESS) values (
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#emp.firstName#">,
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#emp.lastName#">,
				<cfqueryparam cfsqltype="cf_sql_varchar" value="#emp.address#">
			)
		</cfquery>
		
		<cfreturn newEmpResult.generatedKey>
	</cffunction>
	
</cfcomponent>